//
//  PhotosDropView.m
//  Ya.Fotki
//
//  Created by Rim Zaidullin on 22.01.10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "PhotosDropView.h"


@implementation PhotosDropView
- (void) awakeFromNib
{
	[self registerForDraggedTypes:[NSArray arrayWithObjects:NSTIFFPboardType, NSFilenamesPboardType, nil]];
}

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
	
    if (self) {
		[self registerForDraggedTypes:[NSArray arrayWithObjects:NSTIFFPboardType, NSFilenamesPboardType, nil]];
    }
	
    return self;
}

- (void)drawRect:(NSRect)dirtyRect {
	NSColor* bgColor = [NSColor colorWithDeviceRed:48/255.0f green:51/255.0f blue:42/255.0f alpha:1.0];
	[bgColor set];
	[NSBezierPath fillRect:dirtyRect];

	if(filesDraggedOver) {
		NSRect rc = dirtyRect;
		//rc.origin.x += 1;
		rc.origin.y += 1;
		rc.size.height -= 2;
		rc.size.width -= 1;
		[[NSColor blueColor] set];
		[NSBezierPath setDefaultLineWidth:7];
		[NSBezierPath strokeRect:rc];
	}

	/*
	else {
		NSColor* bgColor = [NSColor colorWithDeviceRed:48/255.0f green:51/255.0f blue:42/255.0f alpha:1.0];
		[bgColor set];
	}

	[NSBezierPath fillRect:dirtyRect];
	*/
}

- (NSDragOperation)draggingEntered:(id <NSDraggingInfo>)sender
{
    if((NSDragOperationGeneric & [sender draggingSourceOperationMask]) == NSDragOperationGeneric)
    {
        //this means that the sender is offering the type of operation we want
        //return that we want the NSDragOperationGeneric operation that they 
		//are offering
		filesDraggedOver = YES;
		[self setNeedsDisplay:YES];
        return NSDragOperationGeneric;
    }
    else
    {
		filesDraggedOver = NO;
		[self setNeedsDisplay:YES];
        //since they aren't offering the type of operation we want, we have 
		//to tell them we aren't interested
        return NSDragOperationNone;
    }
}

- (void)draggingExited:(id <NSDraggingInfo>)sender
{
	filesDraggedOver = NO;
	[self setNeedsDisplay:YES];
    //we aren't particularily interested in this so we will do nothing
    //this is one of the methods that we do not have to implement
}

- (NSDragOperation)draggingUpdated:(id <NSDraggingInfo>)sender
{
    if ((NSDragOperationGeneric & [sender draggingSourceOperationMask]) == NSDragOperationGeneric)
    {
        //this means that the sender is offering the type of operation we want
        //return that we want the NSDragOperationGeneric operation that they 
		//are offering
		filesDraggedOver = YES;
        return NSDragOperationGeneric;
    }
    else
    {
		filesDraggedOver = NO;
        //since they aren't offering the type of operation we want, we have 
		//to tell them we aren't interested
        return NSDragOperationNone;
    }
}

- (void)draggingEnded:(id <NSDraggingInfo>)sender
{
    //we don't do anything in our implementation
    //this could be ommitted since NSDraggingDestination is an infomal
	//protocol and returns nothing
	filesDraggedOver = NO;
	[self setNeedsDisplay:YES];
}

- (BOOL)prepareForDragOperation:(id <NSDraggingInfo>)sender
{
    return YES;
}

- (BOOL)performDragOperation:(id <NSDraggingInfo>)sender
{
	return NO;
}

- (void)concludeDragOperation:(id <NSDraggingInfo>)sender
{
    //re-draw the view with our new data
    [self setNeedsDisplay:YES];
}
@end
