//
//  ApplicationDelegate.m
//  FotkiUploader v2.0
//
//  Created by Rim Zaidullin on 18.10.09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "ApplicationDelegate.h"
#import "SettingsManager.h"

@implementation ApplicationDelegate
- (id) init
{
	if(self = [super init]) {
		// load preferences file
		[SettingsMgr loadFromFile];
	}
	
	return self;
}

- (void) awakeFromNib
{
	albumsToGenerate = 106;
	yafUser = [[YafUser alloc] init];
	[yafUser addObserver:self];
 
	[signInWindowController setYafUser:yafUser];
	
	if([SettingsMgr shouldSignInOnStartup] == YES && [SettingsMgr username] && [[SettingsMgr username] length] != 0) {
		[SettingsMgr loadPasswordFromKeychain];
		if([SettingsMgr password] && [[SettingsMgr password] length] != 0) {
			[signInWindowController signInWithUsername:[SettingsMgr username] password:[SettingsMgr password]];
		}
		else {
			[SettingsMgr setShouldSignInOnStartup:NO];
			[signInWindowController showWindow:YES];
		}
	}
	else {
		[signInWindowController showWindow:YES]; // show login screen
	}
	
	[[NSNotificationCenter defaultCenter] addObserver:self
											 selector:@selector(signInSuccessulNotification:)
												 name:YafSignInSuccessfulNotification
											   object:nil];

	[[NSNotificationCenter defaultCenter] addObserver:self
											 selector:@selector(signOutNotification:)
												 name:YafSignOutNotification
											   object:nil];
}

- (void) applicationDidFinishLaunching:(NSNotification *)aNotification
{
}

- (void) applicationWillTerminate:(NSNotification *)aNotification
{
	[yafUser release];
}

- (void) signInSuccessulNotification:(NSNotification *)notification
{
	//[yafUser fetchAlbumWithID:@"90111"];
	
	[mainWindowController setYafUser:yafUser];
	[mainWindowController showWindow:YES];
}

- (void) signOutNotification:(NSNotification *)notification
{
	[mainWindowController showWindow:NO];
	[signInWindowController showLoginPage];
	[signInWindowController showWindow:YES];
}

- (void) yandexFotkiObjectSyncronized:(YaFotkiOperationType)operationType operationData:(NSDictionary*)operationData error:(NSError*)error
{
	if(operationType == YFO_GET_ALBUM) {
		if(!error) {
			//YafAlbum* album = [operationData objectForKey:YafFetchedAlbum];
			//NSLog(@"fetched album INFO: %@", [album description]);
		}
	}
}

- (SignInWindowController*) signInWindowController
{
	return signInWindowController;
}

- (MainWindowController*) mainWindowController
{
	return mainWindowController;
}

- (IBAction) runOperations:(id)sender
{
}
@end
