#import <Cocoa/Cocoa.h>


@interface CCWebpageLink : NSTextField
{
	NSURL* url;
	NSString* linkName;
	NSTrackingRectTag rectTag;
	NSRect textRect;
	BOOL isCursorHoveringOverLink;
	
	int underlineStyle;
	NSColor* color;
	
	int underlineHoverStyle;
	NSColor* hoverColor;
	
	int underlineDownStyle;
	NSColor* downColor;
	
	BOOL isUsernameLink;
	/* from NSAttributedString.h
	 enum {
	 NSUnderlineStyleNone                = 0x00,
	 NSUnderlineStyleSingle              = 0x01,
	 NSUnderlineStyleThick               = 0x02,
	 NSUnderlineStyleDouble              = 0x09
	 };
	 
	 enum {
	 NSUnderlinePatternSolid             = 0x0000,
	 NSUnderlinePatternDot               = 0x0100,
	 NSUnderlinePatternDash              = 0x0200,
	 NSUnderlinePatternDashDot           = 0x0300,
	 NSUnderlinePatternDashDotDot        = 0x0400
	 };	 
	*/
	
	// font name
	// font style
	
//	BOOL mouseIsWithin;
//	BOOL mouseIsDown;
//    NSColor* color;
//    id actionObject;
//    SEL action;
//    BOOL isScreenNameHackEnabled;
}

- (void) setUrl:(NSURL*)aUrl;
- (void) setUrl:(NSURL*)aUrl withLinkName:(NSString*)aLinkName;
- (void) setLinkName:(id)aLinkName;
- (void) setStyleWithUnderline:(int)anUnderlineStyle color:(NSColor*)aColor;
- (void) setHoverStyleWithUnderline:(int)anUnderlineStyle color:(NSColor*)aColor;
- (void) setDownStyleWithUnderline:(int)anUnderlineStyle color:(NSColor*)aColor;
- (void) updateStyle:(enum WebpageLinkState)state;
- (NSTextAlignment) getCurrentTextAlignment;
- (void) setIsUsernameLink:(BOOL)value;
- (void) updateRects;
//- (void)updateStyle;
//- (NSURL*)url;
//- (void)setUrl:(NSURL*)u;
//- (void)setColorWithFloatR:(float)r green:(float)g blue:(float)b;
//- (void)setColorWithIntR:(int)r green:(int)g blue:(int)b;
//- (void)setCallbackObject:(id)object selector:(NSString*)sel;
//- (void)setIsScreenNameHackEnabled:(BOOL)hackOk;
//- (void)setObjectValue:(id)string callbackObject:(id)object selector:(NSString*)sel;
@end