//
//  AlbumsOutlineViewItem.m
//  FotkiUploader v2.0 v2
//
//  Created by Rim Zaidullin on 13.01.10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "AlbumsOutlineViewItem.h"


static AlbumsOutlineViewItem* rootItem = nil;

@implementation AlbumsOutlineViewItem
- (id) initWithObject:(id)anObject parent:(AlbumsOutlineViewItem*)aParent
{
	if(self = [super init]) {
		if(anObject) {
			object = [anObject retain];
		}

		parent = aParent;
		children = [[NSMutableArray alloc] init];
	}
	
	return self;
}

+ (AlbumsOutlineViewItem*) rootItem
{
	if(rootItem == nil) {
		rootItem = [[AlbumsOutlineViewItem alloc] initWithObject:nil parent:nil];
	}
	
	return rootItem;
}

- (NSInteger) numberOfChildren
{	
	return [[self children] count];
}

- (AlbumsOutlineViewItem*) childAtIndex:(NSInteger)index
{
    return [[self children] objectAtIndex:index];
}

- (NSArray*) children
{
	return children;
}

- (void) attachAlbums
{
	if(yafUser) {
		[children removeAllObjects];
		
		for(int i = 0; i < [[yafUser albums] count]; i++) {
			YafAlbum* album = [[yafUser albums] objectAtIndex:i];
			AlbumsOutlineViewItem* child = [[AlbumsOutlineViewItem alloc] initWithObject:album parent:self];
			[children addObject:[child autorelease]];
		}
	}
}

- (NSString*) description
{
	if(!parent) {
		return @"Альбомы"; // just return our string
	}
	else {
		return [(YafAlbum*)object title];
	}
	
	return @"";
}

- (void) setYafUser:(YafUser*)user
{
	[yafUser release];
	yafUser = [user retain];
}

- (AlbumsOutlineViewItem*) parent
{
	return parent;
}

- (id) object
{
	return object;
}

- (void) dealloc
{
	[children release];
	[object release];
	[yafUser release];
	
	[super dealloc];
}
@end
