//
//  MainWindowController.m
//  FotkiUploader v2.0 v2
//
//  Created by Rim Zaidullin on 09.01.10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "MainWindowController.h"
#import "AMIndeterminateProgressIndicatorCell.h"

NSString* const YafSignOutNotification = @"YafSignOutNotification";

@implementation MainWindowController
- (void) awakeFromNib
{
	[[NSNotificationCenter defaultCenter] addObserver:self
											 selector:@selector(albumsViewSelectionChanged:)
												 name:YafAlbumsViewSelectionChangedNotification
											   object:nil];	
}

- (void) albumsViewSelectionChanged:(NSNotification *)aNotification
{
	int albumsCount = [albumsViewController selectedAlbumsCount];
	int imagesCount = [albumsViewController selectedImagesCount];	
	NSString* log = @"";
	
	if(albumsCount != -1) {
		log = [NSString stringWithFormat:@"%d ", albumsCount];
		int albumDecRemainder = albumsCount % 10;
		int albumDecCount = albumsCount / 10;
		
		if(albumDecCount == 1) {
			log = [log stringByAppendingString:@"альбомов, "];
		}
		else {
			if(albumDecRemainder == 1) {
				log = [log stringByAppendingString:@"альбом, "];
			}
			else if(albumDecRemainder >= 2 && albumDecRemainder <= 4) {
				log = [log stringByAppendingString:@"альбома, "];
			}
			else if((albumDecRemainder >= 5 && albumDecRemainder <= 9) || albumDecRemainder == 0) {
				log = [log stringByAppendingString:@"альбомов, "];
			}
		}
	}
	
	log = [log stringByAppendingFormat:@"%d ", imagesCount];
	
	int imagesDecRemainder = imagesCount % 10;
	int imagesDecCount = imagesCount / 10;
	
	if(imagesDecCount == 1) {
		log = [log stringByAppendingString:@"фотографий"];
	}
	else {
		if(imagesDecRemainder == 1) {
			log = [log stringByAppendingString:@"фотография"];
		}
		else if(imagesDecRemainder >= 2 && imagesDecRemainder <= 4) {
			log = [log stringByAppendingString:@"фотографии"];
		}
		else if((imagesDecRemainder >= 5 && imagesDecRemainder <= 9) || imagesDecRemainder == 0) {
			log = [log stringByAppendingString:@"фотографий"];
		}
	}
	
	[selectedAlbumsInfo setStringValue:log];
}

- (void) showWindow:(BOOL)doShow
{
	[window setIsVisible:doShow];
	[albumsTabView selectTabViewItemAtIndex:0];

	//[albumsPopulateProgress setContentAspectRatio:NSMakeSize(1.0, 1.0)];
	/*
	AMIndeterminateProgressIndicatorCell* cell = [[[AMIndeterminateProgressIndicatorCell alloc] init] autorelease];
	[albumsPopulateProgress setCell:cell];
	[cell setSpinning:YES];
	[cell setDisplayedWhenStopped:YES];
	
	NSTimer* theTimer = [NSTimer scheduledTimerWithTimeInterval:[cell animationDelay] target:self selector:@selector(animate:) userInfo:NULL repeats:YES];
	[[NSRunLoop currentRunLoop] addTimer:theTimer forMode:NSEventTrackingRunLoopMode];
	
	[[albumsPopulateProgress cell] setColor:[NSColor whiteColor]];
	*/
}

- (void) animate:(NSTimer *)aTimer
{	double value = fmod(([[albumsPopulateProgress cell] doubleValue] + (5.0/60.0)), 1.0);
	[[albumsPopulateProgress cell] setDoubleValue:value];
	[albumsPopulateProgress setNeedsDisplay:YES];
}

- (IBAction) signOut:(id)sender
{
	NSNotification* myNotification = [NSNotification notificationWithName:YafSignOutNotification object:nil];
	[[NSNotificationQueue defaultQueue] enqueueNotification:myNotification postingStyle:NSPostWhenIdle coalesceMask:NSNotificationCoalescingOnName forModes:nil];
}

- (void) setYafUser:(YafUser*)user
{
	[yafUser release];
	yafUser = [user retain];
	[yafUser removeObserver:self];
	[yafUser addObserver:self];
	
	NSString* userProfileUrl = [NSString stringWithFormat:@"http://fotki.yandex.ru/users/%@/", [yafUser username]];
	
	[usernameLink setIsUsernameLink:YES];
	[usernameLink setUrl:[NSURL URLWithString:userProfileUrl] withLinkName:[yafUser username]];
	
	[albumsViewController setYafUser:yafUser];
	
	[yafUser populateAlbumsList];
}

- (void)windowWillClose:(NSNotification *)notification
{
	[yafUser removeObserver:self];
	[NSApp terminate:self];
}

- (void) yandexFotkiObjectSyncronized:(YaFotkiOperationType)operationType operationData:(NSDictionary*)operationData error:(NSError*)error
{
	if(operationType == YFO_GET_ALBUMS_LIST) {
		if(!error) {
			[albumsTabView selectTabViewItemAtIndex:0];
		}
	}
}
@end
