#import <Cocoa/Cocoa.h>

#define SettingsMgr ([SettingsManager instance])
#define PREFERENCES_PATH @"~/Library/Preferences/ru.yandex.fotki_machine.plist"
#define APP_NAME @"Yandex Fotki Machine"
#define CURRENT_PREFERENCES_FILE_VERSION 1

@interface SettingsManager : NSObject
{
	int configVersion;						 // configuration file version

	NSString* username;
	NSString* password;
	BOOL shouldSignInOnStartup;
}

#pragma mark main utils

+ (SettingsManager*) instance;

// utilities
- (void) loadFromFile;
- (void) saveToFile;
- (int) configVersion;
- (void) setConfigVersion:(int)value;

- (NSString*) username;
- (void) setUsername:(NSString*)value;

- (NSString*) password;
- (void) setPassword:(NSString*)value;
- (void) savePasswordInKeychain;
- (void) loadPasswordFromKeychain;
- (void) removePasswordFromKeychain;

- (BOOL) shouldSignInOnStartup;
- (void) setShouldSignInOnStartup:(BOOL)value;
@end