//
//  SignInWindowController.h
//  FotkiUploader v2.0 v2
//
//  Created by Rim Zaidullin on 09.01.10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "SignInTooltipView.h"
#import "YafUser.h"
#import "CCWebpageLink.h"

extern NSString* const YafSignInSuccessfulNotification;

@interface SignInWindowController : NSObject <YafCatcher>
{
	IBOutlet NSWindow* window;
	
	IBOutlet SignInTooltipView* tooltip;
	IBOutlet NSTextField* errorHeaderText;
	IBOutlet NSTextField* errorMessageText;
	
	IBOutlet NSTabView* tabView;
	IBOutlet NSProgressIndicator* progress;

	IBOutlet NSTextField* login;
	IBOutlet NSTextField* password;
	IBOutlet NSButton* shouldRememberUser;
	IBOutlet CCWebpageLink* forgotPassword;
	
	YafUser* yafUser;
}

- (IBAction) signIn:(id)sender;
- (IBAction) rememberUserSwitch:(id)sender;
- (void) showWindow:(BOOL)doShow;
- (void) setYafUser:(YafUser*)user;
- (void) showSignInFailureTooltip;
- (void) showServerUnavailableTooltip;
- (void) restoreDefaultWindowSize:(BOOL)doAnimate;
- (void) signInWithUsername:(NSString*)aUsername password:(NSString*)aPassword;
- (void) showLoginPage;
@end
