//
//  YaFotkiOperation.h
//  FotkiUploader v2.0 v2
//
//  Created by Rim Zaidullin on 23.12.09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "YaRequest.h"

@class YaOperation;

@protocol YaOperationCatcher
- (void) operationFinished:(YaOperation *)anOperation;
@end

typedef enum _YaFotkiErrorType {
    YafServerUnreachableErrorType = 1,
    YafSignInfailureErrorType	
} YaFotkiErrorType;

// The error domain that all errors generated by Yandex Fotki API use
extern NSString* const YafErrorDomain;

@interface YaOperation : NSObject <YaRequestCatcher>
{
	id<YaOperationCatcher> catcher;
	NSMutableArray* requestsQueue;
	
	BOOL isSuccess;
	NSString* detailedErrorMessage;
	int currentRequestIndex;
	YaRequest* currentRequest;

	NSError* serverUnreacheableError;
	NSError* signInError;
	NSError* yafApiError;
	
	NSError* error;
}

- (id) initWithCatcher:(id<YaOperationCatcher>)aCatcher;
- (void) start;
- (void) setCatcher:(id<YaOperationCatcher>)aCatcher;
- (void) resetOperationData;
- (BOOL) isSuccess;

- (NSString*) detailedErrorMessage;
- (void) setDetailedErrorMessage:(NSString*)anErrorMessage;
- (NSError*) error;
- (void) setError:(NSError*)anError;
@end