//
//  YaStringAdditions.m
//  FotkiUploader v2.0
//
//  Created by Rim Zaidullin on 19.10.09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "YaStringAdditions.h"


@implementation NSString (YAStringEncodingAdditions)

+ (NSString *) encodeStringForXML:(NSString *)stringToEncode
{
	if(!stringToEncode) {
		return nil;
	}
	
    NSArray *escapeChars = [NSArray arrayWithObjects:@"&", @"<", @">", @"'", @"\"", nil];
    NSArray *replaceChars = [NSArray arrayWithObjects:@"&amp;", @"&lt;", @"&gt;", @"&apos;", @"&quot;", nil];
    
    int len = [escapeChars count];
    
    NSMutableString *temp = [[stringToEncode mutableCopy] autorelease];
    
    int i;
    for(i = 0; i < len; i++)
    {
        
        [temp replaceOccurrencesOfString:[escapeChars objectAtIndex:i]
                              withString:[replaceChars objectAtIndex:i]
                                 options:NSLiteralSearch
                                   range:NSMakeRange(0, [temp length])];
    }
    
    NSString *retVal = [NSString stringWithString:temp];
    
    return retVal;
}

+ (NSString *) encodeStringForURL:(NSString *)string
{
    NSString* result = (NSString *)CFURLCreateStringByAddingPercentEscapes(NULL,
																		  (CFStringRef)string,
																		  NULL,
																		  (CFStringRef)@";/?:@&=+$,",
																		  kCFStringEncodingUTF8);
    return [result autorelease];
}

@end

