//
//  YaFotkiAlbum.m
//  FotkiUploader v2.0 v2
//
//  Created by Rim Zaidullin on 24.12.09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "YafAlbum.h"


@implementation YafAlbum
- (id) copyWithZone:(NSZone*)zone
{
    YafAlbum* copy = [[[self class] allocWithZone:zone] init];
	
	[copy setUid:[[uid copy] autorelease]];
	[copy setTitle:[[title copy] autorelease]];
	[copy setSummary:[[summary copy] autorelease]];

	[copy setLinkSelf:[[linkSelf copy] autorelease]];
	[copy setLinkEdit:[[linkEdit copy] autorelease]];
	[copy setLinkPhotos:[[linkPhotos copy] autorelease]];
	[copy setLinkAlternate:[[linkAlternate copy] autorelease]];

	[copy setDatePublished:[[datePublished copy] autorelease]];
	[copy setDateEdited:[[dateEdited copy] autorelease]];
	[copy setDateUpdated:[[dateUpdated copy] autorelease]];

	[copy setIsProtected:isProtected];
	[copy setImageCount:imageCount];
	
	return copy;
}

- (NSString*) description
{
	NSString* retVal = [NSString stringWithFormat:@"\nalbum ID: %@\n", uid];
	retVal = [retVal stringByAppendingFormat:@"title: %@\n", title];
	retVal = [retVal stringByAppendingFormat:@"summary: %@\n", summary];

	retVal = [retVal stringByAppendingFormat:@"link self: %@\n", linkSelf];
	retVal = [retVal stringByAppendingFormat:@"link edit: %@\n", linkEdit];
	retVal = [retVal stringByAppendingFormat:@"link photos: %@\n", linkPhotos];
	retVal = [retVal stringByAppendingFormat:@"link alternate: %@\n", linkAlternate];

	retVal = [retVal stringByAppendingFormat:@"date published: %@\n", datePublished];
	retVal = [retVal stringByAppendingFormat:@"date edited: %@\n", dateEdited];
	retVal = [retVal stringByAppendingFormat:@"date updated: %@\n", dateUpdated];
	
	retVal = [retVal stringByAppendingFormat:@"isProtected: %@\n", isProtected ? @"YES" : @"NO"];
	retVal = [retVal stringByAppendingFormat:@"image count: %d\n", imageCount];
	
	return retVal;
}

- (NSString*) xmlStringValueWithUsername:(NSString*)aUsername albumPassword:(NSString*)aPassword
{
	NSString* username = [aUsername stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
	
	if(!username || [username length] == 0) {
		return nil;
	}
	
	NSMutableString* retVal = [[[NSMutableString alloc] init] autorelease];

	[retVal appendString:@"<entry xmlns=\"http://www.w3.org/2005/Atom\" xmlns:app=\"http://www.w3.org/2007/app\" xmlns:f=\"yandex:fotki\">"];
	[retVal appendFormat:@"<id>urn:yandex:fotki:%@:album:%@</id>", aUsername, uid];
	[retVal appendString:@"<author>"];
    [retVal appendFormat:@"<name>%@</name>", aUsername];
	[retVal appendString:@"</author>"];
	[retVal appendFormat:@"<title>%@</title>", title];
	[retVal appendFormat:@"<summary>%@</summary>", summary];
	[retVal appendFormat:@"<link href=\"%@\" rel=\"self\" />", linkSelf];
	[retVal appendFormat:@"<link href=\"%@\" rel=\"edit\" />", linkEdit];
	[retVal appendFormat:@"<link href=\"%@\" rel=\"photos\" />", linkPhotos];
	[retVal appendFormat:@"<link href=\"%@\" rel=\"alternate\" />", linkAlternate];
	[retVal appendFormat:@"<published>%@</published>", datePublished];
	[retVal appendFormat:@"<app:edited>%@</app:edited>", dateEdited];
	[retVal appendFormat:@"<updated>%@</updated>", dateUpdated];
	
	if(isProtected) {
		[retVal appendString:@"<f:protected value=\"true\" />"];
	}
	else {
		[retVal appendString:@"<f:protected value=\"false\" />"];
	}
	
	if(aPassword != nil) {
		aPassword = [aPassword stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
		
		if([aPassword length] > 0) {
			[retVal appendFormat:@"<f:password>%@</f:password>", aPassword];
		}
	}

	[retVal appendFormat:@"<f:image-count value=\"%d\" />", imageCount];
	[retVal appendString:@"</entry>"];

	return retVal;
}

- (void) setDataFromAlbum:(YafAlbum*)anAlbum
{
	[self setUid:[anAlbum uid]];
	[self setTitle:[anAlbum title]];
	[self setSummary:[anAlbum summary]];
	
	[self setLinkSelf:[anAlbum linkSelf]];
	[self setLinkEdit:[anAlbum linkEdit]];
	[self setLinkPhotos:[anAlbum linkPhotos]];
	[self setLinkAlternate:[anAlbum linkAlternate]];
	
	[self setDatePublished:[anAlbum datePublished]];
	[self setDateEdited:[anAlbum dateEdited]];
	[self setDateUpdated:[anAlbum dateUpdated]];
	
	[self setIsProtected:[anAlbum isProtected]];
	[self setImageCount:[anAlbum imageCount]];
}

- (void) dealloc
{
	[uid retain];
	[title retain];
	[summary retain];
	
	[linkSelf retain];
	[linkEdit retain];
	[linkPhotos retain];
	[linkAlternate retain];
	
	[datePublished retain];
	[dateEdited retain];
	[dateUpdated retain];
	
	[super dealloc];
}

@synthesize uid;
@synthesize title;
@synthesize summary;
@synthesize linkSelf;
@synthesize linkEdit;
@synthesize linkPhotos;
@synthesize linkAlternate;
@synthesize datePublished;
@synthesize dateEdited;
@synthesize dateUpdated;
@synthesize isProtected;
@synthesize imageCount;
@end
