//
//  YaFotkiUser.h
//  FotkiUploader v2.0 v2
//
//  Created by Rim Zaidullin on 24.12.09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import "YafSignInOperation.h"
#import "YafCreateAlbumOperation.h"
#import "YafGetAlbumsListOperation.h"
#import "YafDeleteAlbumOperation.h"
#import "YafGetAlbumOperation.h"
#import "YafEditAlbumOperation.h"

typedef enum _YaFotkiOperationType {
	YFO_SIGN_IN = 1,
	YFO_CREATE_ALBUM,
	YFO_DELETE_ALBUM,
	YFO_GET_ALBUMS_LIST,
	YFO_GET_ALBUM,
	YFO_EDIT_ALBUM
} YaFotkiOperationType;

extern NSString* const YafFetchedAlbum;

@protocol YafCatcher
- (void) yandexFotkiObjectSyncronized:(YaFotkiOperationType)operationType operationData:(NSDictionary*)operationData error:(NSError*)error;
@end

@interface YafUser : NSObject <YaOperationCatcher> {
	NSString* username;
	NSString* password;
	NSString* token;
	NSArray* albums;

	NSMutableArray* observers;
	
	YafSignInOperation* signInOperation;
	YafCreateAlbumOperation* createAlbumOperation;
	YafGetAlbumsListOperation* getAlbumsListOperation;
	YafDeleteAlbumOperation* deleteAlbumOperation;
	YafGetAlbumOperation* getAlbumOperation;
	YafEditAlbumOperation* editAlbumOperation;
}

- (void) addObserver:(id<YafCatcher>)observer;
- (void) removeObserver:(id<YafCatcher>)observer;

- (void) signInWithUsername:(NSString*)aUsername password:(NSString*)aPassword;
- (BOOL) isSignedIn;
- (NSString*) username;
- (NSString*) password;
- (void) populateAlbumsList;
- (NSArray*) albums;
- (void) fetchAlbumWithID:(NSString*)anAlbumID;
- (void) updateAlbumWithID:(NSString*)albumID title:(NSString*)aTitle summary:(NSString*)aSummary password:(NSString*)aPassword;
- (YafAlbum*) getAlbumWithID:(NSString*)anAlbumID;

/*
- (void) createAlbumWithTitle:(NSString*)aTitle summary:(NSString*)aSummary password:(NSString*)aPassword;
- (void) updateAlbumWithID:(NSString*)albumID title:(NSString*)aTitle;
- (void) updateAlbumWithID:(NSString*)albumID summary:(NSString*)aSummary;
- (void) updateAlbumWithID:(NSString*)albumID password:(NSString*)aPassword;
- (void) deleteAlbumWithID:(NSString*)albumID;
- (NSArray*) albums;
*/
@end