//
//  YaFotkiAuthorisationKeyRequestParser.m
//  FotkiUploader v2.0 v2
//
//  Created by Rim Zaidullin on 22.12.09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "YafAuthKeyRequestParser.h"


@implementation YafAuthKeyRequestParser
- (NSDictionary*) parseData:(NSData*)data
{
	// parse xml and get [rsa key] and [rsa reqiest id]
	NSString* xmlString = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
	[xmlString autorelease];
	if(!xmlString || [xmlString length] == 0) {
		return nil;
	}
	
	NSError *errmsg;
	NSXMLDocument *xmlDoc = [[NSXMLDocument alloc] initWithXMLString:xmlString options:NSXMLDocumentXMLKind error:&errmsg];
	[xmlDoc autorelease];

	if(!xmlDoc) {
		return nil;
	}
	
	NSArray *rootElementChildren = [[xmlDoc rootElement] children];
	
	if(!rootElementChildren || [rootElementChildren count] != 2) {
		return nil;
	}
	
	NSString *rsaKey = [[rootElementChildren objectAtIndex:0] stringValue];
	NSString *rsaKeyRequestID = [[rootElementChildren objectAtIndex:1] stringValue];

	// in case key or reqest id are fucked up — generate error
	if(!rsaKey || [rsaKey length] == 0 || !rsaKeyRequestID || [rsaKeyRequestID length] == 0) {
		return nil;
	}

	NSMutableDictionary* retVal = [[[NSMutableDictionary alloc] init] autorelease];
	[retVal setObject:rsaKey forKey:[YafAuthKeyRequestParser dicKeyParsedDataAuthRsaKey]];
	[retVal setObject:rsaKeyRequestID forKey:[YafAuthKeyRequestParser dicKeyRequestID]];
	
	return [[[NSMutableDictionary alloc] initWithDictionary:retVal] autorelease];
}

+ (NSString*) dicKeyParsedDataAuthRsaKey
{
	return @"rsa_key";
}

+ (NSString*) dicKeyRequestID
{
	return @"request_id";
}
@end
