//
//  YaFotkiAuthorisationTokenRequestParser.m
//  FotkiUploader v2.0 v2
//
//  Created by Rim Zaidullin on 23.12.09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "YafAuthTokenRequestParser.h"


@implementation YafAuthTokenRequestParser
- (NSDictionary*) parseData:(NSData*)data
{
	// parse xml and get [rsa key] and [rsa reqiest id]
	NSString* xmlString = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
	[xmlString autorelease];
	if(!xmlString || [xmlString length] == 0) {
		return nil;
	}
	
	NSError *errmsg;
	NSXMLDocument *xmlDoc = [[NSXMLDocument alloc] initWithXMLString:xmlString options:NSXMLDocumentXMLKind error:&errmsg];
	[xmlDoc autorelease];
	
	if(!xmlDoc) {
		return nil;
	}
	
	NSArray *rootElementChildren = [[xmlDoc rootElement] children];
	
	if(!rootElementChildren || [rootElementChildren count] < 1) {
		return nil;
	}
	
	NSXMLElement *xmlFirstElement = [rootElementChildren objectAtIndex:0];
	NSString* token = nil;
	NSString* errorMsg = nil;
	
	// retrieve token
	if([[xmlFirstElement name] isEqualToString:@"token"]) {
		token = [NSString stringWithString:[xmlFirstElement stringValue]];
	}
	else if([[xmlFirstElement name] isEqualToString:@"error"]) {
		errorMsg = [NSString stringWithString:[xmlFirstElement stringValue]];
	}

	NSMutableDictionary* retVal = [[[NSMutableDictionary alloc] init] autorelease];
	
	// in case key or reqest id are fucked up — generate error
	if(token && [token length] > 0) {
		[retVal setObject:token forKey:[YafAuthTokenRequestParser dicKeyTokenID]];
	}
	else if(errorMsg && [errorMsg length] > 0) {
		[retVal setObject:errorMsg forKey:[YafAuthTokenRequestParser dicKeyErrorMessage]];
	}
	else {
		return nil;
	}
	
	return [[[NSDictionary alloc] initWithDictionary:retVal] autorelease];
}

+ (NSString*) dicKeyTokenID
{
	return @"auth_token";
}

+ (NSString*) dicKeyErrorMessage
{
	return @"auth_error";
}
@end