//
//  YafEditAlbumRequestParser.m
//  FotkiUploader v2.0 v2
//
//  Created by Rim Zaidullin on 16.01.10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "YafEditAlbumRequestParser.h"
#import "YafCreateAlbumRequestParser.h"

@implementation YafEditAlbumRequestParser
- (NSDictionary*) parseData:(NSData*)data
{
	NSString* xmlString = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
	[xmlString autorelease];

	if(!xmlString || [xmlString length] == 0) {
		return nil;
	}
	
	NSError *errmsg;
	NSXMLDocument *xmlDoc = [[NSXMLDocument alloc] initWithXMLString:xmlString options:NSXMLDocumentXMLKind error:&errmsg];
	[xmlDoc autorelease];
	
	if(!xmlDoc) {
		return nil;
	}
	
	NSXMLElement* root = [xmlDoc rootElement];
	if([[root name] isEqualToString:@"entry"] == NO) {
		return nil;
	}
	
	[album release];
	album = [YafCreateAlbumRequestParser parseAlbumEntry:root];
	if(album) {
		[album retain];
	}
	else {
		return nil;
	}
	
	NSMutableDictionary* retVal = [[NSMutableDictionary alloc] init];
	if(album) {
		[retVal setObject:album forKey:[YafEditAlbumRequestParser dicKeyAlbum]];
	}
	
	return [NSDictionary dictionaryWithDictionary:[retVal autorelease]];
}

- (YafAlbum*) album
{
	return album;
}

+ (NSString*) dicKeyAlbum
{
	return @"album";
}

- (void) dealloc
{
	[album release];
	
	[super dealloc];
}
@end

