//
//  YafGetAlbumsListRequestParser.m
//  FotkiUploader v2.0 v2
//
//  Created by Rim Zaidullin on 26.12.09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "YafGetAlbumsListRequestParser.h"
#import "YafCreateAlbumRequestParser.h"

@implementation YafGetAlbumsListRequestParser
- (NSDictionary*) parseData:(NSData*)data
{
	NSString* xmlString = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
	[xmlString autorelease];
	
	if(!xmlString || [xmlString length] == 0) {
		return nil;
	}
	
	NSError *errmsg;
	NSXMLDocument *xmlDoc = [[NSXMLDocument alloc] initWithXMLString:xmlString options:NSXMLDocumentXMLKind error:&errmsg];
	[xmlDoc autorelease];
	
	if(!xmlDoc) {
		return nil;
	}
	
	NSArray* elements = [[xmlDoc rootElement] children];
	if([elements count] == 0) {
		return nil;
	}
	
	NSMutableArray* parsedAlbums = [[[NSMutableArray alloc] init] autorelease];
	
	int i;
	for(i = 0; i < [elements count]; i++) {
		NSXMLElement* element = [elements objectAtIndex:i];
		if([[element name] isEqualToString:@"entry"]) {
			YafAlbum* album = [YafCreateAlbumRequestParser parseAlbumEntry:element];
			if(album) {
				[parsedAlbums addObject:album];
			}
			else {
				return nil;
			}
		}
		else if([[element name] isEqualToString:@"link"]) {
			NSArray* attributes = [element attributes];
			NSString* rel = nil;
			NSString* href = nil;
			
			int j;
			for(j = 0; j < [attributes count]; j++) {
				NSXMLNode* node = [attributes objectAtIndex:j];
				
				if([[node name] isEqualToString:@"rel"]) {
					rel = [node stringValue];
				}
				else if([[node name] isEqualToString:@"href"]) {
					href = [node stringValue];
				}		
			}
			
			if(rel){
				if([rel isEqualToString:@"next"] && href && [href length] > 0) {
					[nextPageInCollectionURL release];
					nextPageInCollectionURL = [href copy];
				}
			}
		}
	}
	
	[albums release];
	albums = [[NSArray arrayWithArray:parsedAlbums] retain];
	
	NSMutableDictionary* retVal = [[NSMutableDictionary alloc] init];
	[retVal setObject:albums forKey:[YafGetAlbumsListRequestParser dicKeyAlbumsList]];
	
	if(nextPageInCollectionURL) {
		[retVal setObject:nextPageInCollectionURL forKey:[YafGetAlbumsListRequestParser dicKeyNextPageIncollectionURL]];
	}
	
	return [NSDictionary dictionaryWithDictionary:[retVal autorelease]];
}

- (NSArray*) albums
{
	return albums;
}

- (NSString*) nextPageInCollectionURL
{
	return nextPageInCollectionURL;
}

+ (NSString*) dicKeyAlbumsList
{
	return @"albums_list";
}

+ (NSString*) dicKeyNextPageIncollectionURL
{
	return @"next_page_in_collection";
}

- (void) dealloc
{
	[albums release];
	[nextPageInCollectionURL release];
	
	[super dealloc];
}
@end
