//
//  YafGetAlbumRequest.m
//  FotkiUploader v2.0 v2
//
//  Created by Rim Zaidullin on 15.01.10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "YafGetAlbumRequest.h"


@implementation YafGetAlbumRequest
- (id) initWithCatcher:(id<YaRequestCatcher>)aCatcher parser:(id<YaRequestParser>)aParser
{
	if(self = [super initGetRequest]) {
		[self setParser:aParser];
		[self setCatcher:aCatcher];
		
		[request addRequestHeader:@"Host" value:@"api-fotki.yandex.ru"];
		[request addRequestHeader:@"Accept" value:@"application/atom+xml; type=entry"];
		[request setTimeOutSeconds:10];
	}
	
	return self;
}

- (BOOL) isInputDataOk
{
	BOOL retVal = YES;
	
	if(!username || [username length] == 0) {
		retVal = NO;
	}
	
	if(!token || [token length] == 0) {
		retVal = NO;
	}

	if(!albumID || [albumID length] == 0) {
		retVal = NO;
	}
	
	return retVal;
}

- (void) start
{
	if([self isInputDataOk] == NO) {
		localErrorMessage = @"Malformed request input data!";
		[catcher requestFailed:self];
		return;
	}
	
	RequestUrl = [NSString stringWithFormat:@"http://api-fotki.yandex.ru/api/users/%@/album/%@/", username, albumID];
	[request setURL:[NSURL URLWithString:RequestUrl]];	
	
	NSString* authHeader = [NSString stringWithFormat:@"FimpToken realm=\"fotki.yandex.ru\", token=\"%@\"", token];
	[request addRequestHeader:@"Authorization" value:authHeader];
	
	[super start];
}

- (void) dealloc
{
	[username release];
	[token release];
	[albumID release];
	
	[super dealloc];
}

@synthesize albumID;
@synthesize username;
@synthesize token;
@end
