//
//  YafGetAlbumsListRequest.m
//  FotkiUploader v2.0 v2
//
//  Created by Rim Zaidullin on 26.12.09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "YafGetAlbumsListRequest.h"

@implementation YafGetAlbumsListRequest
- (id) initWithCatcher:(id<YaRequestCatcher>)aCatcher parser:(id<YaRequestParser>)aParser
{
	if(self = [super initGetRequest]) {
		[self setParser:aParser];
		[self setCatcher:aCatcher];

		[request addRequestHeader:@"Host" value:@"api-fotki.yandex.ru"];
		[request setTimeOutSeconds:10];
	}
	
	return self;
}

- (BOOL) isInputDataOk
{
	BOOL retVal = YES;
	
	if(!username || [username length] == 0) {
		retVal = NO;
	}
	
	if(!token || [token length] == 0) {
		retVal = NO;
	}
	
	return retVal;
}

- (void) start
{
	if([self isInputDataOk] == NO) {
		localErrorMessage = @"Malformed request input data!";
		[catcher requestFailed:self];
		return;
	}
	
	if(!nextPageRequestUrl || [nextPageRequestUrl length] == 0) {
		RequestUrl = [NSString stringWithFormat:@"http://api-fotki.yandex.ru/api/users/%@/albums/", username];
		[request setURL:[NSURL URLWithString:RequestUrl]];
	}
	else {
		[request setURL:[NSURL URLWithString:nextPageRequestUrl]];
	}

	
	NSString* authHeader = [NSString stringWithFormat:@"FimpToken realm=\"fotki.yandex.ru\", token=\"%@\"", token];
	[request addRequestHeader:@"Authorization" value:authHeader];
	
	[super start];
}

- (void) dealloc
{
	[username release];
	[token release];
	[nextPageRequestUrl release];
	
	[super dealloc];
}

@synthesize username;
@synthesize token;
@synthesize nextPageRequestUrl;
@end
